//+------------------------------------------------------------------+
//|               MACD_4CZ                           Custom MACD.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|       mod. from ASilver MACD534     http://www.metaquotes.net/ik |
//| MACD_4CZ    4colors  up/dn over/under zero;    www.forexTSD.com  |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2004, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/" 

//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 5
#property  indicator_color1  LimeGreen
#property  indicator_color2  DarkGreen
#property  indicator_color3  Maroon
#property  indicator_color4  Red
#property  indicator_color5  Gold
#property indicator_width1 4
#property indicator_width2 4
#property indicator_width3 4
#property indicator_width4 4
#property indicator_width5 2
#property indicator_level1 0
#property indicator_levelcolor Silver
#property indicator_levelstyle 2

//---- indicator parameters
extern int FastEMA=12;
extern int SlowEMA=26;
extern int SignalPeriod=9;
extern int SignalMAMode = MODE_SMA;
//---- indicator buffers
double green_buffer[];
double DarkGreen_buffer[];
double red_buffer[];
double Maroon_buffer[];
double macd[];
double signal[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   IndicatorBuffers(6);
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(0,green_buffer);
//----
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(1,DarkGreen_buffer);
//----
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(2,red_buffer);
//----
   SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(3,Maroon_buffer);
   SetIndexBuffer(4,signal);
   SetIndexBuffer(5,macd);
//----

   IndicatorDigits(Digits+1);
//---- name for DataWindow and indicator subwindow label
    string short_name="MACD("+FastEMA+","+SlowEMA+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
   SetIndexLabel(1,short_name);
   SetIndexLabel(2,short_name);
   SetIndexLabel(3,short_name);



//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
   int i;
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   for (i = Bars - Max (counted_bars-1, 1); i>=0; i--) 
      macd[i]=iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-
           iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);
   for (i = Bars - Max (counted_bars-1, 1); i>=0; i--) 
   {           
      signal[i] = iMAOnArray(macd,0,SignalPeriod,0,SignalMAMode,i);
      if(macd[i]>0) {
      if ( ( (green_buffer[i+1] != 0) && (macd[i] >= green_buffer[i+1]) ) ||
           ( (DarkGreen_buffer[i+1] != 0) && (macd[i] > DarkGreen_buffer[i+1]) ) ) {
        green_buffer[i] = macd[i];
        DarkGreen_buffer[i] = 0;
      }
      else {
        green_buffer[i] = 0;
        DarkGreen_buffer[i] = macd[i];}
     }
       else {
     if ( ( (red_buffer[i+1] != 0) && (macd[i] >= red_buffer[i+1]) ) ||
           ( (Maroon_buffer[i+1] != 0) && (macd[i] > Maroon_buffer[i+1]) ) ) {
        red_buffer[i] = macd[i];
        Maroon_buffer[i] = 0;
      }
      else {
        red_buffer[i] = 0;
        Maroon_buffer[i] = macd[i];
   } 
      }
   }
//---- done
   return(0);
  }

//+------------------------------------------------------------------+
int Max (int val1, int val2) {
  if (val1 > val2)  return(val1);
  return(val2);
}

